(* Simple example for abstraction and reuse in bNat *)

val nat_tp = Type("nat", []); (* type of natural numbers *)

(* Abstract append_Nil2 theorem: *)
val abs_append_Nil2=  AbsTac.abs_to_thy (theory "Set") append_Nil2

(* Reapply: Instantiate operations, simplify and discharge proof obligations *)
val bNat_add_0_right=  abs_append_Nil2
    |> read_instantiate_sg (sign_of (theory "bNat")) 
       [("nuop0.0", "bPlus"), ("Cons", "%u. bSucc"), ("Nil", "Zero")]
    |> Aux.simp 
    |> comp bNatInduct |> comp bPlus_Zero |> comp bPlus_bSucc;

(* Abstract add_Suc_right theorem *)
val abs_add_Suc_right= 
      AbsTac.abs_to_thy_with (theory "Set") 
        [("0", nat_tp), ("op +", [nat_tp, nat_tp] ---> nat_tp)] 
          add_Suc_right;

(* Reapply: Instantiate and discharge proof obligations. *)
val bNat_add_Suc_right =  abs_add_Suc_right
    |> read_instantiate_sg (sign_of (theory "bNat")) 
       [("nuop0.0", "Zero"), ("Suc", "bSucc"), ("nuop1.0", "bPlus")] 
    |> comp bNatInduct |> comp bPlus_Zero |> comp bPlus_bSucc;


(* Note: we can get away with less instantiations above, but not completely 
 * without. *)
