use "root.sml";

(* set context *)
val thy = the_context ();

goal thy "pMult (pSucc x) One = pSucc (pMult x One)";
by(induct_tac "x" 1); auto(); qed "bNat_Mult_One";

goal thy "pMult (Bit x b) y ~= One";
by (induct_tac "y" 1); auto(); qed "pMult_thm1";

goal thy "pPlus (Bit x False) (Bit y False) = Bit (pPlus x y) False";
auto(); qed "plus0comm";

goal thy "pMult (Bit x True) y = pPlus y (Bit (pMult x y) False)";
auto(); qed "pMult_thm2";

goal thy "pPlus (Bit x False) (pSucc y) = pPlus (Bit x True) y";
Addsimps [(pPluspSuccx RS spec) RS sym]; by(Simp_tac 1);
Delsimps [(pPluspSuccx RS spec) RS sym];
qed "pMultpSuccBitTrue";

goal thy "Bit x True = pSucc (Bit x False)";
auto(); qed "TruepSuccFalse";

(* goal thy "pPlus (pSucc x) y = pSucc (pPlus x y)"; *)
(* pPlussPsuccComm - already proved in bNat.ML *)

goal thy "pMult (pSucc One) y = pPlus y (pMult One y)";
auto(); br (pPlusXX RS sym) 1; qed "pMult_thm3";

goal thy "pPlus (Bit x False) (Bit y False) = Bit (pPlus x y) False";
auto(); qed "pPlusFalseFalse";

goal thy "pPlus (Bit x True) (Bit y False) = Bit (pPlus x y) True";
auto(); qed "pPlusTrueFalse";

goal thy "pPlus (Bit x False) (Bit y True) = Bit (pPlus x y) True";
auto(); qed "pPlusFalseTrue";

goal thy "pPlus (Bit x True) (Bit y True) = Bit (pSucc (pPlus x y)) False";
auto(); 
Addsimps [((pPluspSuccx RS spec) RS sym)]; auto();
Delsimps [((pPluspSuccx RS spec) RS sym)];
br (pPlussPsuccComm RS spec) 1;
qed "pPlusTrueTrue";

goal thy "[| ! Pos y. pMult (pSucc Pos) y = pPlus y (pMult Pos y) |] ==> pMult (pSucc (Pos.Bit Pos False)) y = pPlus y (pMult (Pos.Bit Pos False) y)";
auto(); qed "cond1";

(*
by(case_tac "y" 1); auto();
Addsimps [pPlus_comm]; auto(); Delsimps [pPlus_comm];
qed "cond1";
*)

goal thy "pMult (Bit x True) y = pPlus y (Bit (pMult x y) False)";
by(induct_tac "y" 1); auto(); qed "pMult_lemma1";

goal thy "pMult (Bit x False) y = Bit (pMult x y) False";
auto(); qed "pMult_lemma2";

goal thy "!! x . [|!! y. (pMult x (pSucc y) = pPlus x (pMult x y))|] ==> (pMult (Bit x False) (pSucc y) = pPlus (Bit x False) (pMult (Bit x False) y))";
auto(); qed "testlemma1";

goal thy "Bit x True = pSucc (Bit x False)";
auto(); qed "TrueSuccFalse";

(* Incomplete
goal thy "pPlus x (pPlus y z) = pPlus (pPlus x y) z";
by(induct_tac "x" 1);
Addsimps[pPluspSuccOne]; by(Simp_tac 1); Delsimps[pPluspSuccOne];
Addsimps[pPlussPsuccComm]; by(Simp_tac 1); Delsimps[pPlussPsuccComm];
by(case_tac "bool" 1);
*)
(* PROOF GOAL:
goal thy "! y . (pMult (pSucc x) y = pPlus y (pMult x y))";
by (induct_tac "x" 1);
auto();
Addsimps [(pPlusXX RS sym)]; auto(); Delsimps [(pPlusXX RS sym)];
(* Seems like we neet assoc for pPlus!!! *)

*)




