DataRef = DStruct + 

(* The definition of data refinement *)


constdefs
   pc1 :: "[('a* 'b) set, ('g* 'a) set, ('g* 'b) set ]=> bool"
          "pc1 r ai ci == ! (g, c): ci. ? a . (g, a): ai & (a, c) : r"
 
   pc2 ::  "[('a* 'b) set, 
             (('g* 'a)* ('g* 'a)) set,
             (('g* 'b)* ('g* 'b)) set] => bool"

           "pc2 r aop cop == ! c. 
                             !(g, a): Domain aop. (a, c): r 
                              --> (g, c): Domain cop"

   pc3 :: "[('a* 'b) set, 
            (('g* 'a)* ('g* 'a)) set,
	    (('g* 'b)* ('g* 'b)) set] => bool"

	   "pc3 r aop cop == ! c c' g'. 
                             !(g, a): Domain aop. 
                              (a, c) : r & ((g, c), (g', c')) : cop
                               --> (? a' . ((g, a), (g', a')): aop &
                                           (a', c') : r)"

(* Refinement defined by Woodcock-Davies rule *)

constdefs
   refines :: "[('g, 'a) dstruct, ('g, 'b) dstruct] => bool"
                                                     ("_ [= _" [53,52]52)
              "c [= a == EX r. 
                         let cinit= fst c; cops= snd c; 
			     ainit= fst a; aops= snd a
                         in  (pc1 r ainit cinit &
			     (!i. pc2 r (aops i) (cops i))& 
       			     (!i. pc3 r (aops i) (cops i)))"


end

    
